//
//  MyTableViewController.m
//  TabNavTable
//
//  Created by Blake Ward on 9/1/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "MyTableViewController.h"
#import "TableViewDetailsViewController.h"

@implementation MyTableViewController

@synthesize tableDataList;
@synthesize navCont;

#pragma mark -
#pragma mark View lifecycle

-(void) viewDidLoad {
    NSMutableArray * tempArray = [[[NSMutableArray alloc] initWithObjects:@"Item One", 
                                   @"Item Two", @"Item Three", @"Item Four", @"Item Five", @"Item Six", 
                                   @"Item Seven", 
                                   @"Item Eight", @"Item Nine", @"Item Ten", @"Item Eleven", @"Item Twelve", 
                                   @"Item Thirteen", @"Item Fourteen", @"Item Fifteen", @"Item Sixteen", 
                                   @"Item Seventeen", 
                                   @"Item Eighteen", @"Item Nineteen", @"Item Twenty", nil] autorelease];
    self.tableDataList = tempArray; 
} 

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
}
*/
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


#pragma mark -
#pragma mark Table view data source

-(NSInteger) tableView : (UITableView *) tableView 
  numberOfRowsInSection: (NSInteger) section {
    return [self.tableDataList count]; 
} 

-(UITableViewCell *) tableView : (UITableView *) tableView 
          cellForRowAtIndexPath:(NSIndexPath *) indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"acell"]; 
    if(cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle: 
                 UITableViewCellStyleDefault reuseIdentifier:@"acell"] autorelease]; 
    } 
    cell.textLabel.text = [self.tableDataList objectAtIndex:[indexPath row]]; 
    return cell; 
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


#pragma mark -
#pragma mark Table view delegate

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath: 
(NSIndexPath *) indexPath { 
    NSLog(@"pushing..."); 
    TableViewDetailsViewController * temp = [[[TableViewDetailsViewController alloc] initWithNibName: @"TableViewDetailsViewController" bundle:nil] autorelease]; 
    [self.navCont pushViewController:temp animated:YES]; 
} 


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
    [tableDataList release]; 
    [navCont release];
    [super dealloc];
}


@end
