//
//  MyTableViewController.m
//  TabNavTable
//
//  Created by Blake Ward on 9/1/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//


#import "MyTableViewController.h" 
#import "AddItemViewController.h" 
#import "TableViewDetailsViewController.h" 

@implementation MyTableViewController 
@synthesize tableDataList; 
@synthesize navCont; 
@synthesize addItemController; 
@synthesize addButton; 

-(IBAction) enterAddMode: (id) sender { 
    self.addItemController = [[[AddItemViewController alloc] initWithNibName: @"AddItemViewController" bundle:nil] autorelease];
    [self.navCont pushViewController:self.addItemController animated:YES]; self.addItemController.parentTable = self; 
}

-(void) exitAndSave : (NSString *) newValue { 
    [self.tableDataList addObject: newValue]; 
    [self.navCont popToRootViewControllerAnimated:YES]; 
    [self.tableView reloadData]; 
}

-(void) viewDidLoad {
    NSMutableArray * tempArray = [[[NSMutableArray alloc] initWithObjects: @"Item One", @"Item Two", @"Item Three", @"Item Four", @"Item Five", 
                                   @"Item Six", 
                                   @"Item Seven", @"Item Eight", @"Item Nine", @"Item Ten", @"Item Eleven", @"Item Twelve", @"Item Thirteen", @"Item Fourteen", @"Item Fifteen",
                                   @"Item Sixteen", @"Item Seventeen", @"Item Eighteen", @"Item Nineteen", @"Item Twenty", nil] autorelease];
    self.tableDataList = tempArray;
    self.navigationItem.rightBarButtonItem = self.editButtonItem;
    self.navigationItem.leftBarButtonItem = self.addButton; 
} 

-(NSInteger) tableView : (UITableView *) tableView numberOfRowsInSection: (NSInteger) section {
    return [self.tableDataList count]; 
} 

- (UITableViewCell *) tableView : (UITableView *) tableView cellForRowAtIndexPath: (NSIndexPath *) indexPath { 
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier: @"acell"]; 
    if(cell == nil) { 
        cell = [[[UITableViewCell alloc] initWithStyle: UITableViewCellStyleDefault reuseIdentifier:@"acell"] autorelease]; 
    } 
    cell.textLabel.text = [self.tableDataList objectAtIndex:[indexPath row]]; 
    return cell; 
} 

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath: (NSIndexPath *) indexPath {
    TableViewDetailsViewController * temp = [[[TableViewDetailsViewController alloc] initWithNibName: @"TableViewDetailsViewController" bundle:nil] autorelease];
    [self.navCont pushViewController:temp animated:YES]; 
}

-(void)tableView:(UITableView *)tableView commitEditingStyle: (UITableViewCellEditingStyle)editingStyle forRowAtIndexPath: (NSIndexPath *) indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        [self.tableDataList removeObjectAtIndex:indexPath.row]; 
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        [self.tableDataList insertObject:@"Uninitialized" atIndex:indexPath.row]; 
        [tableView insertRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES]; 
    } 
} 

-(void)tableView:(UITableView *)tableView moveRowAtIndexPath: (NSIndexPath *) fromIndexPath toIndexPath:(NSIndexPath *) toIndexPath {
    id object = [[self.tableDataList objectAtIndex:fromIndexPath.row] retain];
    [self.tableDataList removeObjectAtIndex:fromIndexPath.row];
    [self.tableDataList insertObject:object atIndex: toIndexPath.row];
    [object release]; 
} 

-(UITableViewCellEditingStyle) tableView: (UITableView *) tableView editingStyleForRowAtIndexPath: (NSIndexPath *) indexPath {
    return UITableViewCellEditingStyleDelete; 
} 

-(BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath: (NSIndexPath *) indexPath {
    return YES;
} 

-(BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath: (NSIndexPath *) indexPath {
    return YES;
} 

-(void)dealloc {
    [tableDataList release];
    [navCont release];
    [addItemController release];
    [addButton release];
    [super dealloc]; 
}

@end
