#import "TableHandler.h" 

@implementation TableHandler 

@synthesize tableDataList; 

-(void) fillList { 
    NSArray * tempArrayA = [[[NSArray alloc] initWithObjects:@"AItem One", 
                             @"AItem Two", nil] autorelease]; 
    NSArray * tempArrayB = [[[NSArray alloc] initWithObjects:@"BItem Three", 
                             @"BItem Four", nil] autorelease];
    NSArray * tempArrayC = [[[NSArray alloc] initWithObjects:@"CItem Five", 
                             @"CItem Six", nil] autorelease];
    NSArray * tempArrayD = [[[NSArray alloc] initWithObjects:@"DItem Seven", 
                             @"DItem Eight", nil] autorelease];
    NSArray * tempArrayE = [[[NSArray alloc] initWithObjects:@"EItem Nine", 
                             @"EItem Ten", nil] autorelease];
    NSArray * tempArray = [[[NSArray alloc] initWithObjects:tempArrayA, 
                            tempArrayB, tempArrayC, tempArrayD, tempArrayE, nil] autorelease];
    self.tableDataList = tempArray;
}
 

-(UITableViewCell *) tableView: (UITableView *) tableView cellForRowAtIndexPath: (NSIndexPath *) indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier: @"acell"];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier: @"acell"] autorelease];
    }
    cell.textLabel.text = [[self.tableDataList objectAtIndex:indexPath.section] 
                           objectAtIndex:indexPath.row];
    return cell;
} 

-(NSInteger) numberOfSectionsInTableView: (UITableView *) tableView {
    return [tableDataList count];
} 

-(NSString *) tableView: (UITableView *) tableView 
titleForHeaderInSection: (NSInteger) section {
    switch (section) {
        case 0: return @"A"; break;
        case 1: return @"B"; break;
        case 2: return @"C"; break;
        case 3: return @"D"; break;
        case 4: return @"E"; break;
    }
    return nil; 
} 

-(NSInteger) tableView : (UITableView *) tableView numberOfRowsInSection: (NSInteger) section {
    return [[tableDataList objectAtIndex: section] count];
}

-(void)dealloc { 
    [tableDataList release]; 
    [super dealloc]; 
} 
                                                                                   
@end
