#import "TableHandler.h" 

@implementation TableHandler 

@synthesize tableDataList; 

-(void) fillList { 
    NSArray * tempArrayA = [[[NSArray alloc] initWithObjects:@"AItem One", 
                             @"AItem Two", nil] autorelease]; 
    NSArray * tempArrayB = [[[NSArray alloc] initWithObjects:@"BItem Three", 
                             @"BItem Four", nil] autorelease];
    NSArray * tempArrayC = [[[NSArray alloc] initWithObjects:@"CItem Five", 
                             @"CItem Six", nil] autorelease];
    NSArray * tempArrayD = [[[NSArray alloc] initWithObjects:@"DItem Seven", 
                             @"DItem Eight", nil] autorelease];
    NSArray * tempArrayE = [[[NSArray alloc] initWithObjects:@"EItem Nine", 
                             @"EItem Ten", nil] autorelease];
    NSArray * tempArray = [[[NSArray alloc] initWithObjects:tempArrayA, 
                            tempArrayB, tempArrayC, tempArrayD, tempArrayE, nil] autorelease];
    self.tableDataList = tempArray;
}
 
-(UITableViewCell *) tableView : (UITableView *) tableView cellForRowAtIndexPath: (NSIndexPath *) indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"acell"]; 
    if(cell == nil) { 
        cell = [[[UITableViewCell alloc] initWithStyle: UITableViewCellStyleDefault reuseIdentifier:@"acell"] autorelease];
    }
    cell.textLabel.text = [[self.tableDataList objectAtIndex: indexPath.section] objectAtIndex: indexPath.row];
    UIImage * image;
    switch (indexPath.section) { 
        case 0: image = [UIImage imageNamed:@"power.png"]; break;
        case 1: image = [UIImage imageNamed:@"Icon.png"]; break; 
        case 2: image = [UIImage imageNamed:@"package_graphics.png"]; break;
        case 3: image = [UIImage imageNamed:@"colorize.png"]; break;
        case 4: image = [UIImage imageNamed:@"web.png"]; break;
    } 
    cell.imageView.image = image;
    return cell; 
} 

-(NSInteger) numberOfSectionsInTableView: (UITableView *) tableView {
    return 5;
} 

-(NSString *) tableView: (UITableView *) tableView titleForHeaderInSection: (NSInteger) section {
    switch (section) {
        case 0: return @"A"; break;
        case 1: return @"B"; break;
        case 2: return @"C"; break;
        case 3: return @"D"; break;
        case 4: return @"E"; break;
    }
    return nil; 
} 

-(NSArray *) sectionIndexTitlesForTableView: (UITableView *) tableView {
    NSArray * keys = [[[NSArray alloc] initWithObjects: @"A", @"B", @"C", @"D", @"E",nil] autorelease];
    return keys;
}

-(NSInteger) tableView : (UITableView *) tableView numberOfRowsInSection: (NSInteger) section {
    return 2;
}

-(CGFloat) tableView : (UITableView *) tableView heightForRowAtIndexPath: (NSIndexPath *) indexPath { 
    return 90;
}

-(NSIndexPath *) tableView: (UITableView *) tableView willSelectRowAtIndexPath: (NSIndexPath *) indexPath { 
    NSLog(@"I selected the item at the %d array and %d item, the value is: %@", 
          indexPath.section, indexPath.row, 
          [[self.tableDataList objectAtIndex: indexPath.section] objectAtIndex: indexPath.row]);
    return indexPath; 
} 

-(void)tableView:(UITableView *) tableView didSelectRowAtIndexPath: (NSIndexPath *) index {
    NSLog(@"Yes I did....");
}

-(void)dealloc { 
    [tableDataList release]; 
    [super dealloc]; 
} 
                                                                                   
@end
