//
//  CameraProjectViewController.m
//  CameraProject
//
//  Created by Blake Ward on 9/10/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "CameraProjectViewController.h"
#import "MyImagePickerDelegate.h"

@implementation CameraProjectViewController

@synthesize imgPickerDelegate;
@synthesize theImageView;
@synthesize theTakePhotoButton;

- (void) viewDidLoad {  
    [super viewDidLoad];
    // Only enable the button if a camera is actually available
    theTakePhotoButton.enabled =([UIImagePickerController isSourceTypeAvailable: UIImagePickerControllerSourceTypeCamera]);

    [[NSNotificationCenter defaultCenter] addObserver:self selector: @selector(changeImage) name:@"ImagePicked" object:nil];
}

- (IBAction) takePicture: (id) sender {
    UIImagePickerController * pickCont = [[UIImagePickerController alloc] init]; 
    pickCont.delegate = imgPickerDelegate; 
    pickCont.allowsEditing = YES; 
    pickCont.sourceType = UIImagePickerControllerSourceTypeCamera | UIImagePickerControllerSourceTypePhotoLibrary; 
    [self presentModalViewController:pickCont animated:YES]; 
    NSLog(@"heynow");
}

- (IBAction) selectPicture: (id) sender { 
    UIImagePickerController * pickCont = [[UIImagePickerController alloc] init]; 
    pickCont.delegate = imgPickerDelegate;
    pickCont.allowsEditing = YES; 
    pickCont.sourceType = UIImagePickerControllerSourceTypePhotoLibrary; 
    [self presentModalViewController:pickCont animated:YES]; 
    NSLog(@"heynow"); 
}

- (void) changeImage { 
    NSLog(@"IMAGE CHANGED"); 
    self.theImageView.image = self.imgPickerDelegate.selectedImage;
}

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [theImageView release]; 
    [imgPickerDelegate release]; 
    [super dealloc];
}

@end
