//
//  EncodingAppDelegate.m
//  Encoding
//
//  Created by Blake Ward on 9/11/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "EncodingAppDelegate.h"
#import "EncodingViewController.h"
#import "Foo.h"
#import "Bar.h"

@implementation EncodingAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize myFoo; 
@synthesize myBar; 

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    NSString *pathToFile = [[NSSearchPathForDirectoriesInDomains( NSDocumentDirectory, NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingPathComponent:@"foo2.archive"];
    NSLog(@"%@", pathToFile); 
    NSData * theData =[NSData dataWithContentsOfFile:pathToFile];
    if([theData length] > 0) {
        NSKeyedUnarchiver * archiver = [[[NSKeyedUnarchiver alloc] initForReadingWithData:theData] autorelease];
        myFoo = [[archiver decodeObjectForKey:@"myfoo"] retain];
        myBar = [[archiver decodeObjectForKey:@"mybar"] retain];
        [archiver finishDecoding]; 
        NSLog(@"nth run - name: %@ age: %i", myFoo.name, [myFoo.age intValue]); 
        NSArray * array = myBar.foos;
        for(Foo * aFoo in array) {
            NSLog(@"Foo: name: %@, age: %i", aFoo.name, [aFoo.age intValue]);
        }
    }
    else {
        NSLog(@"first run: no name or age");
        myFoo =[[Foo alloc] init];
        myFoo.name = @"James";
        myFoo.age = [NSNumber numberWithInt:40];
        myBar = [[Bar alloc] init];
    }
    [window addSubview:viewController.view];
    [window makeKeyAndVisible];
    return YES;
}

-(void) applicationWillTerminate: (UIApplication *) application {
    NSString *pathToFile = [[NSSearchPathForDirectoriesInDomains( NSDocumentDirectory, NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingPathComponent:@"foo2.archive"];
    NSMutableData * theData = [NSMutableData data];
    NSKeyedArchiver * archiver = [[[NSKeyedArchiver alloc] initForWritingWithMutableData:theData] autorelease];
    [archiver encodeObject:myFoo forKey:@"myfoo"];
    [archiver encodeObject:myBar forKey:@"mybar"];
    [archiver finishEncoding]; 
    if( [theData writeToFile:pathToFile atomically:YES] == NO)
        NSLog(@"writing failed.");
    else
        NSLog(@"writing succeeded.");
} 

- (void)dealloc {
    [window release];
    [viewController release];
    [super dealloc];
}

@end
