//
//  EncodingAppDelegate.m
//  Encoding
//
//  Created by Blake Ward on 9/11/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "EncodingAppDelegate.h"

#import "EncodingViewController.h"
#import "Foo.h"

@implementation EncodingAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize myFoo; 

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    NSString *pathToFile = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingPathComponent:@"foo.archive"];
    NSLog(@"%@",pathToFile);
    NSData * theData =[NSData dataWithContentsOfFile:pathToFile];
    if([theData length] > 0) {
        NSKeyedUnarchiver * archiver = [[[NSKeyedUnarchiver alloc] initForReadingWithData:theData] autorelease];
        myFoo = [archiver decodeObjectForKey:@"myfoo"];
        [archiver finishDecoding];
        NSLog(@"nth run - name: %@ age: %i", myFoo.name, [myFoo.age intValue]);
    }
    else {
        NSLog(@"first run: no name or age");
        myFoo =[[Foo alloc] init];
        myFoo.name = @"James";
        myFoo.age = [NSNumber numberWithInt:40];
    }     
    [window addSubview:viewController.view];
    [window makeKeyAndVisible];
    return YES;
}

-(void) applicationWillTerminate: (UIApplication *) application {
    NSString *pathToFile = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask,YES) objectAtIndex: 0]stringByAppendingPathComponent:@"foo.archive"];
    NSMutableData * theData = [NSMutableData data];
    NSKeyedArchiver * archiver = [[[NSKeyedArchiver alloc] initForWritingWithMutableData:theData] autorelease];
    [archiver encodeObject:self.myFoo forKey:@"myfoo"];
    [archiver finishEncoding]; 
    if( [theData writeToFile:pathToFile atomically:YES] == NO)
        NSLog(@"writing failed...."); 
} 

- (void)dealloc {
    [window release];
    [viewController release];
    [super dealloc];
}

@end
