//
//  PropertiesAppDelegate.m
//  Properties
//
//  Created by Blake Ward on 9/11/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "PropertiesAppDelegate.h"

#import "PropertiesViewController.h"

@implementation PropertiesAppDelegate


@synthesize window;

@synthesize viewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {

    NSString * errorDescription;
    NSString *pathToFile = [[NSSearchPathForDirectoriesInDomains (NSDocumentDirectory, NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingPathComponent:@"properties.plist"];
    NSData * myData;
    NSLog(@"%@", pathToFile);
    
    if([[NSFileManager defaultManager] fileExistsAtPath:pathToFile] == NO) {
        NSMutableDictionary * dict2Serialize = [[[NSMutableDictionary alloc] init] autorelease];
        NSString * name = @"James";
        NSArray * kids = [NSArray arrayWithObjects:@"Nicolas", @"Juliana", nil];
        NSNumber * age = [NSNumber numberWithInt:40];
        [dict2Serialize setObject:name forKey:@"name"]; 
        [dict2Serialize setObject:kids forKey:@"kids"];
        [dict2Serialize setObject:age forKey:@"age"];
        myData = [NSPropertyListSerialization dataFromPropertyList:(id) dict2Serialize format:NSPropertyListXMLFormat_v1_0 errorDescription:&errorDescription];
        if(myData)
            [myData writeToFile:pathToFile atomically:YES];
        else {
            NSLog(@"Error writing to myData, error: %@", errorDescription);
            [errorDescription release];
        }
    }
    else {
        NSLog(@"property file exists....");
        NSPropertyListFormat format;
        NSData * plistData = [NSData dataWithContentsOfFile:pathToFile];
        NSDictionary * props = (NSDictionary *)[NSPropertyListSerialization propertyListFromData:plistData mutabilityOption:NSPropertyListImmutable format: &format errorDescription: &errorDescription];
        if (props) {
          NSLog(@"name: %@", [props objectForKey:@"name"]);
          NSLog(@"age: %i", [(NSNumber *)[props objectForKey:@"age"]  intValue]);
          NSLog(@"kid: %@", (NSString *)[(NSArray *)[props objectForKey:@"kids"] objectAtIndex:0]);
          NSLog(@"kid: %@", (NSString *)[(NSArray *)[props objectForKey:@"kids"] objectAtIndex:1]);
        } else {
            NSLog(@"Error reading properties, error: %@", errorDescription);
            [errorDescription release];
        }
    }
    
    [window addSubview:viewController.view];
    [window makeKeyAndVisible]; 
    return YES;
}

- (void)applicationWillTerminate:(UIApplication *)application {

    // Save data if appropriate.
}

- (void)dealloc {

    [window release];
    [viewController release];
    [super dealloc];
}

@end
