//
//  MyDBProjectViewController.m
//  MyDBProject
//
//  Created by Blake Ward on 9/13/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "MyDBProjectViewController.h"
#import "PhotoDAO.h";
#import "PhotosDAO.h"; 

@implementation MyDBProjectViewController

@synthesize photos;
@synthesize theImageView;
@synthesize theLabel;

NSInteger currentID = 0;
NSInteger currentElement = 0; 

- (void)viewDidLoad { 
    [PhotosDAO moveDatabase]; 
    PhotosDAO * myPhotos = [[PhotosDAO alloc] init]; 
    self.photos = [myPhotos getAllPhotos]; 
    [self.theImageView setImage:((PhotoDAO *)[self.photos objectAtIndex:0]).photo]; 
    [self.theLabel setText:((PhotoDAO *)[self.photos objectAtIndex:0]).name]; 
    [myPhotos release]; 
    [super viewDidLoad];
}

- (IBAction) changeImage: (id) sender { 
    if(++currentElement == [self.photos count])
        currentElement = 0; 
    PhotoDAO * aPhoto = (PhotoDAO *) [self.photos objectAtIndex: currentElement]; 
    currentID = aPhoto.photoID; 
    [self.theLabel setText:aPhoto.name];  
    [self.theImageView setImage:aPhoto.photo];
}

- (IBAction) addThirdPhoto: (id) sender { 
    static BOOL wasAdded; 
    if(!wasAdded) { 
        PhotosDAO * myPhotos = [[PhotosDAO alloc] init]; 
        PhotoDAO * aPhoto = [[PhotoDAO alloc] init]; 
        NSString * imgPath = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:@"photo3.png"]; 
        aPhoto.name = @"Another photo"; 
        aPhoto.photo = [[UIImage alloc] initWithContentsOfFile:imgPath]; 
        [myPhotos addPhoto:aPhoto];  
        [self.photos release]; 
        self.photos = [myPhotos getAllPhotos]; 
        [myPhotos release]; 
        wasAdded = YES;
    }
}

-(IBAction) changePhotosImage: (id) sender { 
    PhotosDAO * myPhotos = [[PhotosDAO alloc] init]; 
    NSString * imgPath = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:@"photo4.png"]; 
    [myPhotos changeAPhotoImage:[[UIImage alloc] initWithContentsOfFile: imgPath] theID: currentID]; 
    [self.photos release]; 
    self.photos = [myPhotos getAllPhotos]; 
    [myPhotos release];
}

- (IBAction) deletePhoto : (id) sender { 
    PhotosDAO * myPhotos = [[PhotosDAO alloc] init]; 
    [myPhotos deletePhoto:currentID]; 
    [self.photos release]; 
    self.photos = [myPhotos getAllPhotos]; 
    currentElement = 0; 
    [myPhotos release];
}

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [photos release]; 
    [theImageView release]; 
    [theLabel release]; 
    [super dealloc];
}

@end
