//
//  PhotosDAO.m
//  MyDBProject
//
//  Created by Blake Ward on 9/13/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "PhotosDAO.h"
#import "PhotoDAO.h"

@implementation PhotosDAO

- (NSMutableArray *) getAllPhotos { 
    NSMutableArray * photosArray = [[NSMutableArray alloc] init]; 
    @try {  
        NSFileManager *fileManager = [NSFileManager defaultManager]; 
        NSString *theDBPath = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:@"myDatabase.sqlite"]; 
        BOOL success = [fileManager fileExistsAtPath:theDBPath]; 
        if (!success) {
            NSLog(@"Failed to find database file '%@'.", theDBPath);
        } 
        if (!(sqlite3_open([theDBPath UTF8String], &database) == SQLITE_OK)) { 
            NSLog(@"An error opening database, normally handle error here.");  
        }  
        const char *sql = "SELECT id,name,photo FROM photos"; 
        sqlite3_stmt *statement; 
        if (sqlite3_prepare_v2(database, sql, -1, &statement, NULL) != SQLITE_OK){ 
            NSLog(@"Error, failed to prepare statement, normally handle error here."); 
        } 
        while (sqlite3_step(statement) == SQLITE_ROW) { 
            PhotoDAO * aPhoto = [[PhotoDAO alloc] init]; 
            aPhoto.photoID = sqlite3_column_int(statement, 0); 
            aPhoto.name = [NSString stringWithUTF8String:(char *)sqlite3_column_text(statement, 1)]; 
            const char * rawData = sqlite3_column_blob(statement, 2); 
            int rawDataLength = sqlite3_column_bytes(statement, 2); 
            NSData *data = [NSData dataWithBytes:rawData length: rawDataLength]; 
            aPhoto.photo = [[UIImage alloc] initWithData:data];  
            [photosArray addObject:aPhoto]; 
            [aPhoto release]; 
        } 
        if(sqlite3_finalize(statement) != SQLITE_OK){ 
            NSLog(@"Failed to finalize data statement, normally error handling here."); 
        } 
        if (sqlite3_close(database) != SQLITE_OK) { 
            NSLog(@"Failed to close database, normally error handling here."); 
        } 
    } 
    @catch (NSException *e) { 
        NSLog(@"An exception occurred: %@", [e reason]); 
        return nil; 
    } 
    return photosArray;
} 
@end
