//
//  AKCGroupViewController.m
//  DogBreeds
//
//  Created by Blake Ward on 9/15/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "AKCGroupViewController.h"
#import "AKCGroup.h"

@implementation AKCGroupViewController

@synthesize nameField;
@synthesize groupDescriptionField;
@synthesize group;

@synthesize insertingGroup;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.nameField.text = self.group.name;
    self.groupDescriptionField.text = self.group.groupDescription;
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    UIBarButtonItem *doneButton = [[UIBarButtonItem alloc]
                                   initWithBarButtonSystemItem:UIBarButtonSystemItemDone
                                   target:self action:@selector(done)];
    self.navigationItem.rightBarButtonItem = doneButton;
    [doneButton release];

    UIBarButtonItem *cancelButton = [[UIBarButtonItem alloc]
                                   initWithBarButtonSystemItem:UIBarButtonSystemItemCancel
                                   target:self action:@selector(cancel)];
    self.navigationItem.leftBarButtonItem = cancelButton;
    [cancelButton release];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)done {
    self.group.name = nameField.text;
    [self.nameField resignFirstResponder];
    self.group.groupDescription = groupDescriptionField.text;
    [self.groupDescriptionField resignFirstResponder];
    NSError *error = nil;
    if (![self.group.managedObjectContext save:&error]) {
		// Be sure to handle any errors
    }
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)cancel {
    [self.nameField resignFirstResponder];
    [self.groupDescriptionField resignFirstResponder];
    
    // If this was a new group that was created, then cancel should get rid of the empty group from the database
    if (insertingGroup == YES) {
        // Delete the managed object for the given index path
        NSManagedObjectContext *context = self.group.managedObjectContext;
        [context deleteObject:self.group];
        
        // Save the deletion
        NSError *error = nil;
        if (![context save:&error]) {
            NSLog(@"Failed to save to data store: %@", [error localizedDescription]);
            NSArray* detailedErrors = [[error userInfo] objectForKey:NSDetailedErrorsKey];
            if(detailedErrors != nil && [detailedErrors count] > 0) {
                for(NSError* detailedError in detailedErrors) {
                    NSLog(@"  DetailedError: %@", [detailedError userInfo]);
                }
            }
            else {
                NSLog(@"  %@", [error userInfo]);
            }
            abort();
        }
    }
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)dealloc {
    [group release];
    [nameField release];
    [groupDescriptionField release];
    [super dealloc];
}


@end
