//
//  iPodSongsViewController.m
//  iPodSongs
//
//  Created by Blake Ward on 10/7/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "iPodSongsViewController.h"
#import "MyMediaPickerDelegate.h"

@implementation iPodSongsViewController

@synthesize mediaControllerDelegate;
@synthesize mediaLib; 
@synthesize currentTitle;
@synthesize currentArtist;
@synthesize currentLengthInSeconds;
@synthesize player;
@synthesize volumeView;

int currentItem = 0; 

-(void) viewDidLoad {
    [MPMediaLibrary defaultMediaLibrary];
    [[NSNotificationCenter defaultCenter] addObserver:self selector: @selector(songsPicked:) name:@"SongsPicked" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector: @selector(songChanged) name:@"MPMusicPlayerControllerNowPlayingItemDidChangeNotification" object:nil];
    mpVolumeView = [[MPVolumeView alloc] init];
    [mpVolumeView setFrame:[self.volumeView bounds]];
    [self.volumeView addSubview:mpVolumeView]; 
} 

- (void) songsPicked: (NSNotification *) notification {
    player = [MPMusicPlayerController applicationMusicPlayer];
    player.repeatMode = MPMusicRepeatModeNone;
    player.shuffleMode = MPMusicShuffleModeOff;
    [player setQueueWithItemCollection:(MPMediaItemCollection *) [notification object]];
    [player beginGeneratingPlaybackNotifications];
    [player play]; 
} 

-(void) songChanged {
    MPMediaItem * tempMediaItem = (MPMediaItem *)player.nowPlayingItem; [self.currentTitle setText:[tempMediaItem valueForProperty: MPMediaItemPropertyTitle]];
    [self.currentArtist setText: [tempMediaItem valueForProperty: MPMediaItemPropertyArtist]];
    [self.currentLengthInSeconds setText: [NSString stringWithFormat:@"%i", [tempMediaItem valueForProperty:MPMediaItemPropertyPlaybackDuration]]];
} 

-(IBAction) changeState: (id) sender {
    NSInteger num = ((UIControl*)sender).tag;
    switch (num) {
        case 1: [player pause]; break;
        case 2: [player play]; break;
        case 3: [player stop]; break;
        case 4: [player skipToPreviousItem]; break; 
        case 5: [player skipToNextItem]; break;
    }
} 

-(IBAction) selectSongs: (id) sender {
    MPMediaPickerController * mediaController = 
    [[MPMediaPickerController alloc] init];
    mediaController.allowsPickingMultipleItems = YES; mediaController.delegate = [[MyMediaPickerDelegate alloc] init];
    [self presentModalViewController:mediaController animated:YES]; 
} 

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

-(void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [mediaControllerDelegate release];
    [player stop];
    [mpVolumeView release];
    [super dealloc]; 
}

@end
