//
//  BreedDetailViewController_iPad.m
//  DogBreeds
//
//  Created by Blake Ward on 10/12/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "BreedDetailViewController_iPad.h"
#import "Breed.h"
#import "AKCGroup.h"

@implementation BreedDetailViewController_iPad

@synthesize toolbar;
@synthesize popover;
@synthesize navButton;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/

-(void)updateBreed: (Breed *)theBreed {
    if (self.popover) {
        [self.popover dismissPopoverAnimated:YES];
        if (self.navButton != nil) {
            self.navButton.title = theBreed.group.name;
            [self.toolbar setNeedsDisplay];
        }
    }

    self.selectedBreed = theBreed;
    [self updateDetails];
    [self.view setNeedsDisplay];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}

- (void)splitViewController:(UISplitViewController*)svc willHideViewController:(UIViewController *)aViewController
          withBarButtonItem:(UIBarButtonItem*)barButtonItem forPopoverController:(UIPopoverController*)pc {
    // If there's a breed already displayed in the details view, then the button
    // should show which group it's in when the pop-over isn't visible
    self.navButton = barButtonItem;
    if (self.selectedBreed != nil)
        barButtonItem.title = self.selectedBreed.group.name;
    else
       barButtonItem.title = aViewController.title;
    [self.toolbar setItems:[NSArray arrayWithObject:barButtonItem] animated:YES];
    self.popover = pc;
    
    // Adjust the photo and description to fit nicely in portrait mode
    CGRect portraitPhotoFrame = photo.frame;
    portraitPhotoFrame.origin.x = 135;
    portraitPhotoFrame.origin.y = 50;
    photo.frame = portraitPhotoFrame;
    CGRect descFrame = breedDescription.frame;
    descFrame.size.height = 560;
    descFrame.origin.x = 85;
    descFrame.origin.y = 410;
    breedDescription.frame = descFrame;
}

- (void)splitViewController: (UISplitViewController*)svc willShowViewController:(UIViewController *)aViewController
  invalidatingBarButtonItem:(UIBarButtonItem *)barButtonItem {
    [self.toolbar setItems:[NSArray array] animated:YES];
    self.popover = nil;
    self.navButton = nil;
    
    // Adjust the photo and description to fit nicely in landscape mode
    CGRect portraitPhotoFrame = photo.frame;
    portraitPhotoFrame.origin.x = 100;
    portraitPhotoFrame.origin.y = 20;
    photo.frame = portraitPhotoFrame;
    CGRect descFrame = breedDescription.frame;
    descFrame.size.height = 360;
    descFrame.origin.x = 50;
    descFrame.origin.y = 375;
    breedDescription.frame = descFrame;
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [navButton release];
    [toolbar release];
    [popover release];
    [super dealloc];
}


@end
