//
//  MoviePlayerViewController.m
//  MoviePlayer
//
//  Created by Blake Ward on 10/7/10.
//  Copyright (c) 2010 __MyCompanyName__. All rights reserved.
//

#import "MoviePlayerViewController.h"

@implementation MoviePlayerViewController

@synthesize movieplayer; 

-(IBAction) playMovie: (id) sender {
    movieplayer = [[MPMoviePlayerController alloc] initWithContentURL: [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"short" ofType:@"3gp"]]];
    [[NSNotificationCenter defaultCenter] addObserver:self selector: @selector (playingDone) name:MPMoviePlayerPlaybackDidFinishNotification object:nil];
    // Only iOS 3.2 and above respond to the loadState selector
    if ([movieplayer respondsToSelector:@selector(loadState)]) {
        // Our application runs in portrait orientation, so on iOS 3.2 and later, the movie
        // player will also display in portrait mode, with it's status bar visible by default.
        // The next few lines change the orientation to landscape
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight animated:NO];
        
        // Rotate the view for landscape playback
        [[self view] setBounds:CGRectMake(0, 0, 480, 320)];
        [[self view] setCenter:CGPointMake(160, 240)];
        [[self view] setTransform:CGAffineTransformMakeRotation(M_PI / 2)]; 
        
        // Set frame of movie player
        [[movieplayer view] setFrame:CGRectMake(0, 0, 480, 320)];

        // Add movie player as subview
        [[self view] addSubview:[movieplayer view]];   
        
        // Play the movie
        [movieplayer play];
    } else {
        // Prior to iOS 3.2, this was enough to play the movie correctly
        [movieplayer play];
    }
}

-(void) playingDone {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [[movieplayer view] removeFromSuperview];
    movieplayer = nil; 
} 


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


-(void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [movieplayer release];
    [super dealloc]; 
}

@end
